/*-
 * Copyright (c) 2004 Jacques A. Vidrine
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#ifndef CELABO_20040211_HANDLERS_HH
#define CELABO_20040211_HANDLERS_HH
namespace vuxml {


class Parser;


class BasicHandler : public XMLHandler {
public:

  BasicHandler(EntryProcessor &proc);
  virtual ~BasicHandler();

  virtual void setParser(Parser &parser);

  virtual void startElement(std::string &xmlns, std::string &name,
      Attributes &attr);
  virtual void endElement(std::string &xmlns, std::string &name);
  virtual void characters(std::string &pcdata);

private:
  Parser	*parser_;
  EntryProcessor &proc_;
  XMLState	*state_;


#include <vuxml/state_proto.hh>
#include <vuxml/state_head.hh>
#include <vuxml/basic_state.hh>
#include <vuxml/state_undef.hh>

#define CLASS BasicHandler
#include <vuxml/state_member.hh>
#include <vuxml/state_head.hh>
#include <vuxml/basic_state.hh>
#include <vuxml/state_undef.hh>

  std::stack<XMLState *>	state_stack_;

  XMLState	*top_state();
  XMLState	*pop_state();
  void		 push_state(XMLState *state);

  std::string	tmp_;
  VersionRange	range_;
  std::auto_ptr<Entry> entry_;

  XMLState	*signalError_(const char *msg);
};


}
#endif
